



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ASP.NET脚本过滤-防止跨站脚本攻击(收集别人的)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ASP.NET脚本过滤-防止跨站脚本攻击(收集别人的)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 18:11:38 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>ASP.Net 1.1后引入了对提交表单自动检查是否存在XSS（跨站脚本攻击）的能力。当用户试图用&lt;xxxx&gt;之类的输入影响页面返回结果的时候，ASP.Net的引擎会引发一个&nbsp;HttpRequestValidationExceptioin。默认情况下会返回如下文字的页面：</p>
<table>
<tbody>
<tr>
<td>Server Error in '/YourApplicationPath' Application<br /><br />A potentially dangerous Request.Form value was detected from the client<br>(txtName="&lt;b&gt;").<br /><br />Description:&nbsp;Request Validation has detected a potentially dangerous client input value, and processing of the request has been aborted. This value may indicate an attempt to compromise the security of your application, such as a cross-site scripting attack. You can disable request validation by setting validateRequest=false in the Page directive or in the configuration section. However, it is strongly recommended that your application explicitly check all inputs in this case.<br /><br />Exception Details:&nbsp;System.Web.HttpRequestValidationException: A potentially dangerous Request.Form value was detected from the client (txtName="&lt;b&gt;").<br /><br />....</td>
</tr>
</tbody>
</table>
<p>这是ASP.Net提供的一个很重要的安全特性。因为很多程序员对安全没有概念，甚至都不知道XSS这种攻击的存在，知道主动去防护的就更少了。ASP.Net在这一点上做到默认安全。这样让对安全不是很了解的程序员依旧可以写出有一定安全防护能力的网站。<br /><br />但是，当我Google搜索&nbsp;HttpRequestValidationException&nbsp;或者 "A potentially dangerous Request.Form value was detected from the client"的时候，惊奇的发现大部分人给出的解决方案竟然是在ASP.Net页面描述中通过设置&nbsp;validateRequest=false&nbsp;来禁用这个特性，而不去关心那个程序员的网站是否真的不需要这个特性。看得我这叫一个胆战心惊。安全意识应该时时刻刻在每一个程序员的心里，不管你对安全的概念了解多少，一个主动的意识在脑子里，你的站点就会安全很多。<br /><br />为什么很多程序员想要禁止 validateRequest 呢？有一部分是真的需要用户输入"&lt;&gt;"之类的字符。这就不必说了。还有一部分其实并不是用户允许输入那些容易引起XSS的字符，而是讨厌这种报错的形式，毕竟一大段英文加上一个ASP.Net典型异常错误信息，显得这个站点出错了，而不是用户输入了非法的字符，可是自己又不知道怎么不让它报错，自己来处理报错。<br /><br />对于希望很好的处理这个错误信息，而不使用默认ASP.Net异常报错信息的程序员们，你们不要禁用validateRequest=false。<br /><br />正确的做法是在你当前页面添加Page_Error()函数，来捕获所有页面处理过程中发生的而没有处理的异常。然后给用户一个合法的报错信息。如果当前页面没有Page_Error()，这个异常将会送到Global.asax的Application_Error()来处理，你也可以在那里写通用的异常报错处理函数。如果两个地方都没有写异常处理函数，才会显示这个默认的报错页面呢。<br /><br />举例而言，处理这个异常其实只需要很简短的一小段代码就够了。在页面的Code-behind页面中加入这么一段代码：</p>
<div>
<div><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/None.gif">protected&nbsp;void&nbsp;Page_Error(object&nbsp;sender,&nbsp;EventArgs&nbsp;e)<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/ExpandedBlockStart.gif">{<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/InBlock.gif">&nbsp;&nbsp;&nbsp;&nbsp;Exception&nbsp;ex&nbsp;=&nbsp;Server.GetLastError();<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/InBlock.gif">&nbsp;&nbsp;&nbsp;&nbsp;if&nbsp;(ex&nbsp;is&nbsp;HttpRequestValidationException)<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/ExpandedSubBlockStart.gif">&nbsp;&nbsp;&nbsp;&nbsp;{<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/InBlock.gif">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Response.Write("请您输入合法字符串。");<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/InBlock.gif">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Server.ClearError();&nbsp;//&nbsp;如果不ClearError()这个异常会继续传到Application_Error()。<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/ExpandedSubBlockEnd.gif">&nbsp;&nbsp;&nbsp;&nbsp;}<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/ExpandedBlockEnd.gif">}</div>
</div>
<p>这样这个程序就可以截获 HttpRequestValidationException 异常，而且可以按照程序员的意愿返回一个合理的报错信息。<br /><br />这段代码很简单，所以我希望所有不是真的要允许用户输入&lt;xxx&gt;之类字符的朋友，千万不要随意的禁止这个安全特性，如果只是需要异常处理，那么请用类似于上面的代码来处理即可。<br /><br />而对于那些通过 明确禁止了这个特性的程序员，自己一定要明白自己在做什么，而且一定要自己手动的检查必须过滤的字符串，否则你的站点很容易引发跨站脚本攻击。<br /><br />关于存在Rich Text Editor的页面应该如何处理？<br /><br />如果页面有富文本编辑器的控件的，那么必然会导致有&lt;xxx&gt;类的HTML标签提交回来。在这种情况下，我们不得不将validateRequest="false"。那么安全性怎么处理？如何在这种情况下最大限度的预防跨站脚本攻击呢？<br /><br />根据微软的建议，我们应该采取安全上称为“默认禁止，显式允许”的策略。<br /><br />首先，我们将输入字符串用 HttpUtility.HtmlEncode()来编码，将其中的HTML标签彻底禁止。<br /><br />然后，我们再对我们所感兴趣的、并且是安全标签，通过Replace()进行替换。比如，我们希望有"&lt;b&gt;"标签，那么我们就将"&amp;lt;b&amp;gt;"显式的替换回"&lt;b&gt;"。<br /><br />示例代码如下：</p>
<div>
<div><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/None.gif">&nbsp;&nbsp;void&nbsp;submitBtn_Click(object&nbsp;sender,&nbsp;EventArgs&nbsp;e)<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/ExpandedBlockStart.gif">&nbsp;&nbsp;{<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/InBlock.gif">&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;将输入字符串编码，这样所有的HTML标签都失效了。<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/InBlock.gif">&nbsp;&nbsp;&nbsp;&nbsp;StringBuilder&nbsp;sb&nbsp;=&nbsp;new&nbsp;StringBuilder(<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/InBlock.gif">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;HttpUtility.HtmlEncode(htmlInputTxt.Text));<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/InBlock.gif">&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;然后我们选择性的允许&lt;b&gt; 和 &lt;i&gt;<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/InBlock.gif">&nbsp;&nbsp;&nbsp;&nbsp;sb.Replace("&amp;lt;b&amp;gt;",&nbsp;"&lt;b&gt;");<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/InBlock.gif">&nbsp;&nbsp;&nbsp;&nbsp;sb.Replace("&amp;lt;/b&amp;gt;",&nbsp;"");<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/InBlock.gif">&nbsp;&nbsp;&nbsp;&nbsp;sb.Replace("&amp;lt;i&amp;gt;",&nbsp;"&lt;i&gt;");<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/InBlock.gif">&nbsp;&nbsp;&nbsp;&nbsp;sb.Replace("&amp;lt;/i&amp;gt;",&nbsp;"");<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/InBlock.gif">&nbsp;&nbsp;&nbsp;&nbsp;Response.Write(sb.ToString());<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/ExpandedBlockEnd.gif">&nbsp;&nbsp;}</div>
</div>
<p>这样我们即允许了部分HTML标签，又禁止了危险的标签。<br /><br />根据微软提供的建议，我们要慎重允许下列HTML标签，因为这些HTML标签都是有可能导致跨站脚本攻击的。</p>
<ul><li>&lt;<strong>applet</strong>&gt;</li>
<li>&lt;<strong>body</strong>&gt;</li>
<li>&lt;<strong>embed</strong>&gt;</li>
<li>&lt;<strong>frame</strong>&gt;</li>
<li>&lt;<strong>script</strong>&gt;</li>
<li>&lt;<strong>frameset</strong>&gt;</li>
<li>&lt;<strong>html</strong>&gt;</li>
<li>&lt;<strong>iframe</strong>&gt;</li>
<li>&lt;<strong>img</strong>&gt;</li>
<li>&lt;<strong>style</strong>&gt;</li>
<li>&lt;<strong>layer</strong>&gt;</li>
<li>&lt;<strong>link</strong>&gt;</li>
<li>&lt;<strong>ilayer</strong>&gt;</li>
<li>&lt;<strong>meta</strong>&gt;</li>
<li>&lt;<strong>object</strong>&gt;</li></ul>
<p>可能这里最让人不能理解的是&lt;img&gt;。但是，看过下列代码后，就应该明白其危险性了。</p>
<div>
<div><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/None.gif">&lt;img&nbsp;src="javascript:alert('hello');"&gt;<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/None.gif">&lt;img&nbsp;src="java script:alert('hello');"&gt;<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/None.gif">&lt;img&nbsp;src="java script:alert('hello');"&gt;</div>
</div>
<p>通过&lt;img&gt;标签是有可能导致Javascript执行的，这样攻击者就可以做他想伪装的任何事情。<br /><br />关于&lt;style&gt;也是一样：</p>
<div>
<div><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/ExpandedBlockStart.gif">&lt;style&nbsp;TYPE="text/javascript"&gt;<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/ExpandedBlockEnd.gif">&nbsp;&nbsp;alert('hello');<br><img referrerpolicy="no-referrer"src="http://images.csdn.net/syntaxhighlighting/OutliningIndicators/None.gif">&lt;/style&gt;</div>
</div>
<p>参考：<br /><br />HOW TO: 使用 Visual C# .NET 在 ASP.NET 中创建自定义错误报告<br><a href="http://support.microsoft.com/kb/306355/zh-cn" rel="external nofollow noreferrer">http://support.microsoft.com/kb/306355/zh-cn</a><br /><br />HttpRequestValidationException 类 (System.Web)<br><a href="http://msdn2.microsoft.com/zh-cn/library/system.web.httprequestvalidationexception%28VS.80%29.aspx" rel="external nofollow noreferrer">http://msdn2.microsoft.com/zh-cn/library/system.web.httprequestvalidationexception(VS.80).aspx</a><br /><br />MSDN: How To: Prevent Cross-Site Scripting in ASP.NET<br><a href="http://msdn2.microsoft.com/en-us/library/ms998274.aspx" rel="external nofollow noreferrer">http://msdn2.microsoft.com/en-us/library/ms998274.aspx</a><br /><br />推荐大家阅读微软关于.Net安全的一系列文章：<br><a href="http://msdn2.microsoft.com/en-us/library/ms978512.aspx" rel="external nofollow noreferrer">http://msdn2.microsoft.com/en-us/library/ms978512.aspx</a><br /><br />关于跨站脚本攻击请参考：<br /><br />Wikipedia 维基大百科全书<br><a href="http://en.wikipedia.org/wiki/Cross_site_scripting" rel="external nofollow noreferrer">http://en.wikipedia.org/wiki/Cross_site_scripting</a><br /><br />Xfocus<br><a href="http://www.xfocus.org/articles/200607/874.html" rel="external nofollow noreferrer">http://www.xfocus.org/articles/200607/874.html</a><br /><br />Google<br><a href="http://www.google.com/search?q=%E8%B7%A8%E7%AB%99%E8%84%9A%E6%9C%AC%E6%94%BB%E5%87%BB" rel="external nofollow noreferrer">http://www.google.com/search?q=%E8%B7%A8%E7%AB%99%E8%84%9A%E6%9C%AC%E6%94%BB%E5%87%BB</a></p>
<p>Trackback: http://tb.blog.csdn.net/TrackBack.aspx?PostId=1560171</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqdgpgxq.html">jenkins自动部署maven工程到服务器----SSH&plus;shell</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv3g6j8.html">c&plus;&plus;引用总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq46w058.html">Channel SDK &lpar;渠道SDK&rpar; for Unity</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy74vmq.html">利用jquery实现自动登录</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnxl739.html">linux特殊符号大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdewdx09.html">ab压测参数说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojnw4xq.html">Chapter 5&period;依赖倒转原则</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zzp6e9.html">使用C&num;实现顺序队列</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1y5kjq.html">Keil中使用Astyel进行C语言的格式化</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z7o5x9.html">php 即时输出</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mde7j8.html">thinkphp整合系列之短信验证码、订单通知</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd6p379.html">Oracle查询优化改写--------------------范围处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geyxr78.html">Sqoop-1&period;4&period;6 Merge源码分析与改造使其支持多个merge-key</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojenylq.html">HotSpot 虚拟机垃圾回收算法实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p1w1n8.html">eclipse快捷键 （包括查找类、方法、变量）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdwpxd9.html">定义一个Map集合&comma;key和value不规定类型，任意放入数据，用keySet&lpar;&rpar;和    entrySet&lpar;&rpar;两种方式遍历出Map集合的数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwewv78.html">Python内存优化：Profile，slots，compact dict</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2515kvq.html">OSG模拟鼠标事件影响操纵器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllype1q.html">mysql 入门   jdbc</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g574eq.html">SQL SERVER 查看SQL语句IO&comma;时间，索引消耗</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8ojv0xeq.html">spring mvc 与 jasper Report集成</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yd4yz8.html">delphi BitmapCompress</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj2o7j8.html">Oracle 11g 的安装及配置详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kp1449.html">ROM、RAM、DRAM、SRAM和FLASH的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy14m0mq.html">asp&period;net权限认证：OWIN实现OAuth 2&period;0 之密码模式（Resource Owner Password Credential）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdk13k9.html">集成支付宝-iOS</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj5nkpq.html">计算机程序的思维逻辑 &lpar;66&rpar; - 理解synchronized</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv10vx1q.html">css居中问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp5pm59.html">构建Docker平台【第二篇】安装 Docker</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4znz009.html">linux下载时提示请尝试移除磁盘中不需要的文件并重试，或者保存到其他位置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
